﻿using Microsoft.EntityFrameworkCore;
using Waaagh.Models;
using Waaagh.Services.Abstract;

namespace Waaagh.Services {
    internal class MessageManager: IMessageManager {

        private IDbContextFactory<AppDatabaseContext> DbContextFactory { get; }

        public MessageManager(IDbContextFactory<AppDatabaseContext> dbContextFactory) {
            DbContextFactory = dbContextFactory;
            Templates = new Dictionary<string, Message>();
            Messages = new Dictionary<string, Message>();
        }

        private Dictionary<string, Message> Templates { get; set; }
        private Dictionary<string, Message> Messages { get; set; }



        public void SaveMessagesAsync() {

        }

        public void LoadMessages() {
            AppDatabaseContext dbContext = DbContextFactory.CreateDbContext();
            foreach (Message message in dbContext.Messages) {
                if (Messages.TryAdd(message.Name, message) == false) {
                    Messages[message.Name].UpdateReferences(message);
                }
            }
        }
    }
}
