﻿using System.Collections.ObjectModel;
using CommunityToolkit.Mvvm.ComponentModel;
using CommunityToolkit.Mvvm.Input;

namespace WpfSample.ViewModels {
    internal partial class DemoGroupViewModel: ObservableObject {
        public DemoGroupViewModel() {
            Random random = new Random();
            for (int i = random.Next(1, 10); i >= 0; --i) {
                Items.Add(new DemoItemViewModel() {
                    Name = $"I{i}",
                    Value = $"V{random.Next()}",
                });
            }
        }

        [ObservableProperty]
        [NotifyPropertyChangedFor(nameof(Message))]
        private string name = string.Empty;

        public ObservableCollection<DemoItemViewModel> Items { get; } = new ObservableCollection<DemoItemViewModel>();

        public string Message => $"{Name}-{Items.Count}";

        [RelayCommand]
        private void AddItem() {
            Random random = new Random();
            Items.Add(new DemoItemViewModel() {
                Name = $"I{random.Next()}",
                Value = $"V{random.Next()}",
            });
        }
    }
}
